package com.yuanta.smartnet.sample.view;

import android.content.Context;
import android.graphics.Color;
import android.text.InputType;
import android.text.method.PasswordTransformationMethod;
import android.util.DisplayMetrics;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.TextView;

public class SampleBaseView extends FrameLayout
{
	public SampleBaseView(Context context) 
	{
		super(context);
		// TODO Auto-generated constructor stub
	}

	public String[] getStockAcctType() {
		return stockAcctType;
	}

	public void setStockAcctType(String[] stockAcctType) {
		this.stockAcctType = stockAcctType;
	}

	/**
	 * 주식주문 계좌타입
	 */
	String[] stockAcctType = {"A01010001","A01010002","A01010003","A03010001","A03020001","A03020002", "A03030001","A03030009","A03030013","A03040002","A03040003","A03040004","A03040005","A03040006","A03040007","A03040008","A03040009","A03040010","A03040011","A03040012","A03040024","A06010001","A06010002","A06010003"};

	public String[] getForeignAcctType() {
		return foreignAcctType;
	}

	public void setForeignAcctType(String[] foreignAcctType) {
		this.foreignAcctType = foreignAcctType;
	}

	/**
	 * 해외주식 계좌타입
	 * @param strText
	 * @return
	 */
	String[] foreignAcctType = {"A01010001","A01010002","A01010003"};

	//Text view 생성
	protected TextView makeTextView(String strText)
	{
		return makeTextView(strText, 20, Color.BLACK);
	}
	
	protected TextView makeTextView(String strText, int nTextDip, int nTextColor)
	{
		TextView viewText = new TextView(getContext());
		viewText.setTextColor(nTextColor);
		viewText.setTextSize(TypedValue.COMPLEX_UNIT_DIP, nTextDip);
		viewText.setGravity(Gravity.LEFT | Gravity.CENTER_VERTICAL);
		viewText.setText(strText);
		viewText.setSingleLine();
		
		return viewText;
	}
	
	//Edit view 생성
	protected EditText makeEditView(String strText)
	{
		EditText viewEdit = new EditText(getContext());
		viewEdit.setTextColor(Color.BLACK);
		viewEdit.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 20);
		viewEdit.setGravity(Gravity.LEFT | Gravity.CENTER_VERTICAL);
		viewEdit.setText(strText);
		viewEdit.setSingleLine();
		
		return viewEdit;
	}	

	//Edit 속성 생성	
	protected void setEditText(EditText viewEdit, boolean isNormal, boolean isNumber)
	{
		viewEdit.setLongClickable(false);
		viewEdit.setFocusableInTouchMode(true);
		viewEdit.setFocusable(true);
		viewEdit.setEllipsize(null);
       	viewEdit.setPrivateImeOptions("defaultInputmode=english;");
    	viewEdit.setImeOptions(EditorInfo.IME_ACTION_DONE);

        if(isNormal)
        {
        	if(isNumber)
        		viewEdit.setInputType(InputType.TYPE_CLASS_NUMBER);
        	else
        		viewEdit.setInputType(InputType.TYPE_TEXT_VARIATION_URI | InputType.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD);
        }
        else
        {
        	if(isNumber)
        		viewEdit.setInputType(InputType.TYPE_CLASS_NUMBER |InputType.TYPE_TEXT_VARIATION_PASSWORD);
        	else
        		viewEdit.setInputType(InputType.TYPE_CLASS_TEXT |InputType.TYPE_TEXT_VARIATION_PASSWORD);
        	viewEdit.setTransformationMethod(PasswordTransformationMethod.getInstance());
        }
	}
	
	//Button view 생성
	protected Button makeCtrlButton(int nCtrlId, String strText)
	{
		Button button = new Button(getContext());	
		button.setTextColor(Color.BLACK);
		button.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 20);
		button.setGravity(Gravity.CENTER);
		button.setText(strText);
		button.setSingleLine();
		button.setId(nCtrlId);
		button.setPadding(0, 0, 0, 0);

		return button;
	}
	
	protected CheckBox makeCheckBox(int nCtrlId, String strText)
	{
		CheckBox box = new CheckBox(getContext());
		
		box.setText(strText);
		box.setId(nCtrlId);
		box.setTextColor(Color.BLACK);
		box.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 20);
		
		return box;
	}
	
	
	//버튼 Listener 셋팅
	public void setCtrlClickListener(int nCtrlId, OnClickListener listener)
	{
		View view = findViewById(nCtrlId);
		if(view == null) return;
		
		view.setOnClickListener(listener);
	}
	

}
