package com.yuanta.smartnet.sample.view;

import com.itgen.corelib.util.ConfigUtil;
import com.itgen.corelib.util.TRACE;
import com.yuanta.smartnet.proc.SmartNetMng;
import com.yuanta.smartnet.sample.view.sub.CertSelectSpinner;
import com.yuanta.smartnet.sample.view.util.SampleUtil;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.Checkable;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

//로그인 뷰
@SuppressLint("ClickableViewAccessibility")
public class SampleLoginView
extends SampleBaseView
implements View.OnClickListener, CompoundButton.OnCheckedChangeListener
{
	private static final String LOG_TAG = "LoginView";
	
	public interface ID
    {
        int     CTRL_ID_LOGIN = 100;
        int     CTRL_ID_CANCEL = 101;
        int		CTRL_ID_CERTSEL = 102;
        int		CTRL_ID_CERTCHECK = 103;
        int		CTRL_ID_MOTULOGIN = 104;
    }
	
	private Activity	m_activity;

	private String      m_strUserId = "";
	private String      m_strUserPwd = "";
	private String		m_strCertDN = "";
	private String      m_strAuthPwd = "";
	private boolean		m_isCertLogin = false;
	private boolean		m_isMotuLogin = false; //모의투자 로그인
 	
    private EditText	m_editUserId;
	private EditText	m_editUserPwd;
	private CertSelectSpinner		m_spinnerCert;
	private EditText	m_editCertPwd;
	private CheckBox	m_checkCertLogin;
	private CheckBox 	m_checkMotuLogin;

	public SampleLoginView(Context context)
	{
		super(context);
		// TODO Auto-generated constructor stub
	}
	
	public void setActivity(Activity act)
	{
		m_activity = act;
	}
	
	public Activity getActivity()
	{
		return m_activity;
	}
	
	//초기화
	public void initView()
	{
		int nTitleWidth = (int)SampleUtil.dipToPixels(getContext(), 100);	// 입력항목 제목 너비
		int nInputWidth = (int)SampleUtil.dipToPixels(getContext(), 200);	// 입력항목 에디트 너비
		int nInputPaddingH = (int)SampleUtil.dipToPixels(getContext(), 20);	// 입력항목 가로 패딩
		int nInputPaddingV = (int)SampleUtil.dipToPixels(getContext(), 10);	// 입력항목 세로 패딩
		int nInputHeight = (int)SampleUtil.dipToPixels(getContext(), 46);	// 입력항목 높이
		int nButtonWidth = (int)SampleUtil.dipToPixels(getContext(), 100);	// 버튼 너비
		int nButtonHeight = (int)SampleUtil.dipToPixels(getContext(), 50);	// 버튼 높이
		
		LinearLayout layoutFrame = new LinearLayout(getContext());
		layoutFrame.setOrientation(LinearLayout.VERTICAL);
		//아이디
		TextView viewIDTitle = makeTextView("아이디");
		m_editUserId = makeEditView("");
		
		LinearLayout layoutID = new LinearLayout(getContext());
		layoutID.setOrientation(LinearLayout.HORIZONTAL);
		
		layoutID.addView(viewIDTitle, new LinearLayout.LayoutParams(nTitleWidth, nInputHeight));
		layoutID.addView(m_editUserId, new LinearLayout.LayoutParams(nInputWidth, nInputHeight));
		layoutID.setPadding(nInputPaddingH, nInputPaddingV, nInputPaddingH, 0);
		layoutFrame.addView(layoutID, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
		
		setEditText(m_editUserId, true, false);
		//비밀번호
		TextView viewPWTitle = makeTextView("비밀번호");
		m_editUserPwd = makeEditView("");
	
		LinearLayout layoutPW = new LinearLayout(getContext());
		layoutPW.setOrientation(LinearLayout.HORIZONTAL);
		
		layoutPW.addView(viewPWTitle, new LinearLayout.LayoutParams(nTitleWidth, nInputHeight));
		layoutPW.addView(m_editUserPwd, new LinearLayout.LayoutParams(nInputWidth, nInputHeight));
		layoutPW.setPadding(nInputPaddingH, nInputPaddingV, nInputPaddingH, 0);
		layoutFrame.addView(layoutPW, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
		
		setEditText(m_editUserPwd, false, false);
		
		// 인증서
		TextView viewCertTitle = makeTextView("인증서");
		m_spinnerCert = new CertSelectSpinner(getContext());
		m_spinnerCert.setCertList(SmartNetMng.getInstance().getUserCertList());
		m_spinnerCert.setCertDN(ConfigUtil.getSessionCertDN());

   		m_spinnerCert.setOnCertSelectedListener(new CertSelectSpinner.OnCertSelectedListener()
		{
			@Override
			public void onCertSelected(String strDN)
			{
				m_strCertDN = strDN;
				
				ConfigUtil.setSessionCertDN(strDN);
			}
   			
		});
		
		LinearLayout layoutCert = new LinearLayout(getContext());
		layoutCert.setOrientation(LinearLayout.HORIZONTAL);
		
		layoutCert.addView(viewCertTitle, new LinearLayout.LayoutParams(nTitleWidth, nInputHeight));
		layoutCert.addView(m_spinnerCert, new LinearLayout.LayoutParams(nInputWidth, nInputHeight));
		layoutCert.setPadding(nInputPaddingH, nInputPaddingV, nInputPaddingH, 0);
		layoutFrame.addView(layoutCert, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
		
		//공인인증
		TextView viewCertPWTitle = makeTextView("공인인증");
		m_editCertPwd = makeEditView("");
		
		LinearLayout layoutCertPW = new LinearLayout(getContext());
		layoutCertPW.setOrientation(LinearLayout.HORIZONTAL);
		
		layoutCertPW.addView(viewCertPWTitle, new LinearLayout.LayoutParams(nTitleWidth, nInputHeight));
		layoutCertPW.addView(m_editCertPwd, new LinearLayout.LayoutParams(nInputWidth, nInputHeight));
		layoutCertPW.setPadding(nInputPaddingH, nInputPaddingV, nInputPaddingH, nInputPaddingV);	
		layoutFrame.addView(layoutCertPW, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
	
		setEditText(m_editCertPwd, false, false);
		
		// 공인인증만으로 로그인
		m_checkCertLogin = makeCheckBox(ID.CTRL_ID_CERTCHECK, "인증서만으로 로그인");
		LinearLayout layoutCertCheck = new LinearLayout(getContext());
		layoutCertCheck.setOrientation(LinearLayout.HORIZONTAL);
		
		layoutCertCheck.addView(m_checkCertLogin, new LinearLayout.LayoutParams(nInputWidth, nInputHeight));
		
		layoutFrame.addView(layoutCertCheck, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
		m_checkCertLogin.setOnCheckedChangeListener(this);


		// 모의투자로 로그인
		m_checkMotuLogin = makeCheckBox(ID.CTRL_ID_MOTULOGIN, "모의투자");
		LinearLayout layoutMotuCheck = new LinearLayout(getContext());
		layoutMotuCheck.setOrientation(LinearLayout.HORIZONTAL);

		layoutMotuCheck.addView(m_checkMotuLogin, new LinearLayout.LayoutParams(nInputWidth, nInputHeight));

		layoutFrame.addView(layoutMotuCheck, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
		m_checkMotuLogin.setOnCheckedChangeListener(this);


		
		//버튼	
		Button buttonLogin = makeCtrlButton(ID.CTRL_ID_LOGIN, "로그인");
		Button buttonCancel = makeCtrlButton(ID.CTRL_ID_CANCEL, "취소");
			
		LinearLayout layoutbtn = new LinearLayout(getContext());
		layoutbtn.setOrientation(LinearLayout.HORIZONTAL);
		layoutbtn.setPadding(0, nInputPaddingV, 0, nInputPaddingV);	
		layoutbtn.addView(buttonLogin, new LinearLayout.LayoutParams(nButtonWidth, nButtonHeight));
		layoutbtn.addView(buttonCancel, new LinearLayout.LayoutParams(nButtonWidth, nButtonHeight));
		
		LinearLayout.LayoutParams paramButtons = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
		paramButtons.gravity = Gravity.CENTER_HORIZONTAL;
		layoutFrame.addView(layoutbtn, paramButtons);
	
		addView(layoutFrame, new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));
		
		buttonLogin.setOnClickListener(this);
		buttonCancel.setOnClickListener(this);
		
		setInputState();
	}


	public void releaseView()
	{
		removeAllViews();

		m_editUserId = null;
		m_editUserPwd = null;
		m_editCertPwd = null;
	}
	
	private void setInputState()
	{
		m_editUserId.setEnabled(!m_isCertLogin);
		m_editUserPwd.setEnabled(!m_isCertLogin);
		m_spinnerCert.setEnabled(m_isCertLogin);
		m_editCertPwd.setEnabled(true);
		m_checkMotuLogin.setEnabled(!m_isCertLogin);

		m_isMotuLogin = false;


		
		m_editUserId.setTextColor(m_isCertLogin ? Color.LTGRAY : Color.BLACK);
		m_editUserPwd.setTextColor(m_isCertLogin ? Color.LTGRAY : Color.BLACK);
	}

	private void setMotuInputState()
	{
		m_editUserId.setEnabled(true);
		m_editUserPwd.setEnabled(true);
		m_spinnerCert.setEnabled(false);
		m_editCertPwd.setEnabled(!m_isMotuLogin);

		m_checkCertLogin.setEnabled(!m_isMotuLogin);

		m_isCertLogin = false;


		m_editCertPwd.setTextColor(m_isMotuLogin ? Color.LTGRAY : Color.BLACK);


	}

	@Override
	public void onClick(View v)
	{
		if(m_activity == null) return;

		int nCtrlId = v.getId();
		/**
		 * 사용자가 로그인을 요청 할 때 로그인에 필요한 정보를 확인 하고
		 * 필요한 정보가 전부 입력되지 않았을 경우 해당 정보를 요청하는 메시지를 보여주거나
		 * 필요한 정보가 모두 갖춰졌을 때 해당정보를 기반으로 로그인을 요청한다.
		 */
		switch(nCtrlId)
		{
		case ID.CTRL_ID_LOGIN :


			// 일반(모투)로그인 ID빈칸
			if( (!m_isCertLogin || m_isMotuLogin )&& getUserId().isEmpty() )
			{
				Toast.makeText( m_activity, "아이디를 확인하세요.", Toast.LENGTH_SHORT ).show();
				return;
			}


		    else if( (!m_isCertLogin || m_isMotuLogin) && getUserPwd().isEmpty())
		    {
		    	Toast.makeText( m_activity, "비밀번호를 확인하세요.", Toast.LENGTH_SHORT ).show();
		        return;
		    }
		    else if(m_isCertLogin && m_spinnerCert.getSelectedItem() == null)
		    {
		    	Toast.makeText( m_activity, "공인인증서를 선택하세요.", Toast.LENGTH_SHORT ).show();
		    	return;
		    }
		    else if(!m_isMotuLogin && getCertPwd().isEmpty() )
		    {
		    	Toast.makeText( m_activity, "공인인증 비밀번호를 확인하세요.", Toast.LENGTH_SHORT ).show();
		        return;
		    }

		    
		    //로그인 시작
		    if(m_isCertLogin)
		    	SmartNetMng.getInstance().startLogin(getCertDN(), getCertPwd());
			//모의투잘 로그인시작
		    else if(m_isMotuLogin)
				SmartNetMng.getInstance().startMotuLogin(getUserId(), getUserPwd());
			else

		    	SmartNetMng.getInstance().startLogin(getUserId(), getUserPwd(), getCertPwd());
			
			break;
		/**
		 * 유저가 로그인 취소를 할 경우
		 */
		case ID.CTRL_ID_CANCEL :
			
			m_activity.finish();
			
			break;


		}



	}

	@Override
	public void onCheckedChanged(CompoundButton button, boolean isChecked)
	{
		if(button.getId() == ID.CTRL_ID_CERTCHECK)
		{
			m_isCertLogin = isChecked;

			setInputState();


		}

		if(button.getId() == ID.CTRL_ID_MOTULOGIN)
		{

			m_isMotuLogin = isChecked;

			setMotuInputState();

		}
	}

	/**
	 * Activity에서 유저 아이디란에 세팅을 위한 함수
	 * @param strUserId
	 */
	public void setUserId(String strUserId)
	{
		m_editUserId.setText(strUserId);
		m_strUserId = strUserId;
	}
	/**
	 * 입력된 아이디를 리턴
	 * @return
	 */
	public String getUserId()
	{
		m_strUserId = m_editUserId.getText().toString();
		return m_strUserId ;
	}
	
	/**
	 * Activity에서 View의 유저 비밀번호란에 세팅을 위한 함수
	 * @param strUserPwd
	 */
	public void setUserPwd(String strUserPwd)
	{
		m_strUserPwd = strUserPwd;
		m_editUserPwd.setText(strUserPwd);
	}
	
	/**
	 *입력된 비밀번호를 리턴
	 * @return
	 */
	public String getUserPwd()
	{
		m_strUserPwd = m_editUserPwd.getText().toString();
		return m_strUserPwd;
	}
	
	public void setCertDN(String strCertDN)
	{
		m_strCertDN = strCertDN;
	}
	
	public String getCertDN()
	{
		return m_strCertDN;
	}
	
	/**
	 *Activity에서 View의 유저 비밀번호란에 세팅을 위한 함수
	 * @param strCertPwd
	 */
	public void setCertPwd(String strCertPwd)
	{
		m_editCertPwd.setText(strCertPwd);
	}
	
	/**
	 * 입력된 공인인증 비밀번호를 리턴
	 * @return
	 */
	public String getCertPwd()
	{
		m_strAuthPwd = m_editCertPwd.getText().toString();
		return m_strAuthPwd;
	}

}
